--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_xioctl.c	Mon Aug  5 17:28:45 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_xioctl.c	Mon Aug  5 17:28:45 2019
@@ -8850,7 +9371,7 @@
 		cmd->ResponseLen = 0;
 	} else {
 		cmd->ResponseLen = EXT_DEF_DCBX_PARAM_BUF_SIZE;
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 	kmem_free(tmp_buf, EXT_DEF_DCBX_PARAM_BUF_SIZE);
 
@@ -8876,9 +9397,9 @@
 {
 	EXT_CNA_PORT	cna_port = {0};
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if (!(CFG_IST(ha, CFG_CTRL_8081))) {
+	if (!(CFG_IST(ha, CFG_FCOE_SUPPORT))) {
 		EL(ha, "invalid request for HBA\n");
 		cmd->Status = EXT_STATUS_INVALID_REQUEST;
 		cmd->ResponseLen = 0;
@@ -8907,7 +9428,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (EXT_CNA_PORT);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -8934,7 +9455,7 @@
 	uint32_t			ver_len, transfer_size;
 	PEXT_ADAPTERREGIONVERSION	padapter_ver = NULL;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* 8142s do not have a EDC PHY firmware. */
 	mpi_cap = (uint8_t)(ha->mpi_capability_list >> 8);
@@ -9008,7 +9529,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = ver_len;
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 
 	kmem_free(padapter_ver, ver_len);
@@ -9037,7 +9558,7 @@
 	int8_t			*tmp_buf;
 	EXT_MENLO_MANAGE_INFO	info;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/*  Verify the size of request structure. */
 	if (cmd->RequestLen < sizeof (EXT_MENLO_MANAGE_INFO)) {
@@ -9104,10 +9625,10 @@
 		cmd->ResponseLen = 0;
 	} else {
 		cmd->ResponseLen = info.TotalByteCount;
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 	kmem_free(tmp_buf, size);
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -9127,9 +9648,9 @@
 	EXT_FCF_LIST		fcf_list = {0};
 	ql_fcf_list_desc_t	mb_fcf_list = {0};
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if (!(CFG_IST(ha, CFG_CTRL_81XX))) {
+	if (!(CFG_IST(ha, CFG_FCOE_SUPPORT))) {
 		EL(ha, "invalid request for HBA\n");
 		cmd->Status = EXT_STATUS_INVALID_REQUEST;
 		cmd->ResponseLen = 0;
@@ -9189,7 +9710,7 @@
 		cmd->ResponseLen = 0;
 	} else {
 		cmd->ResponseLen = mb_fcf_list.buffer_size;
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 
 	kmem_free(tmp_buf, fcf_list.BufSize);
@@ -9211,15 +9732,8 @@
 	ql_mbx_data_t		mr;
 	EXT_RESOURCE_CNTS	tmp_rc_cnt = {0};
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if (!(CFG_IST(ha, CFG_CTRL_242581))) {
-		EL(ha, "invalid request for HBA\n");
-		cmd->Status = EXT_STATUS_INVALID_REQUEST;
-		cmd->ResponseLen = 0;
-		return;
-	}
-
 	if (cmd->ResponseLen < sizeof (EXT_RESOURCE_CNTS)) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
 		cmd->DetailStatus = sizeof (EXT_RESOURCE_CNTS);
@@ -9243,8 +9757,12 @@
 	tmp_rc_cnt.OrgXchgCtrlCnt = (uint32_t)mr.mb[6];
 	tmp_rc_cnt.CurIocbBufCnt = (uint32_t)mr.mb[7];
 	tmp_rc_cnt.OrgIocbBufCnt = (uint32_t)mr.mb[10];
-	tmp_rc_cnt.NoOfSupVPs = (uint32_t)mr.mb[11];
-	tmp_rc_cnt.NoOfSupFCFs = (uint32_t)mr.mb[12];
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
+		tmp_rc_cnt.NoOfSupVPs = (uint32_t)mr.mb[11];
+	}
+	if (CFG_IST(ha, CFG_FCOE_SUPPORT)) {
+		tmp_rc_cnt.NoOfSupFCFs = (uint32_t)mr.mb[12];
+	}
 
 	rval = ddi_copyout((void *)&tmp_rc_cnt,
 	    (void *)(uintptr_t)(cmd->ResponseAdr),
@@ -9255,6 +9773,952 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (EXT_RESOURCE_CNTS);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
+}
+
+/*
+ * ql_get_temperature
+ *	Get ASIC temperature data
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	cmd:	EXT_IOCTL cmd struct pointer.
+ *	mode:	flags
+ *
+ * Returns:
+ *	None, request status indicated in cmd->Status.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static void
+ql_get_temperature(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
+{
+	ql_mbx_data_t	mr;
+	int		rval = 0;
+	EXT_BOARD_TEMP	board_temp = {0};
+
+	QL_PRINT_9(ha, "started\n");
+
+	if (!(ha->fw_ext_attributes & TEMP_SUPPORT_ISP)) {
+		EL(ha, "invalid request for HBA\n");
+		cmd->Status = EXT_STATUS_INVALID_REQUEST;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	if (cmd->ResponseLen < sizeof (EXT_BOARD_TEMP)) {
+		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
+		cmd->DetailStatus = sizeof (EXT_BOARD_TEMP);
+		EL(ha, "failed, ResponseLen < EXT_BOARD_TEMP, "
+		    "Len=%xh \n", cmd->ResponseLen);
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	switch (cmd->SubCode) {
+	case EXT_SC_GET_BOARD_TEMP:
+		rval = ql_get_temp(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			/* error */
+			EL(ha, "failed, get_temperature_mbx=%xh\n", rval);
+			cmd->Status = EXT_STATUS_ERR;
+			cmd->ResponseLen = 0;
+			break;
+		}
+		board_temp.IntTemp = mr.mb[1];
+
+		rval = ddi_copyout((void *)&board_temp,
+		    (void *)(uintptr_t)(cmd->ResponseAdr),
+		    sizeof (EXT_BOARD_TEMP), mode);
+		if (rval != 0) {
+			cmd->Status = EXT_STATUS_COPY_ERR;
+			cmd->ResponseLen = 0;
+			EL(ha, "failed, ddi_copyout\n");
+		} else {
+			cmd->ResponseLen = sizeof (EXT_BOARD_TEMP);
+		}
+		break;
+	default:
+		EL(ha, "unknown subcode=%xh\n", cmd->SubCode);
+		cmd->Status = EXT_STATUS_ERR;
+		cmd->ResponseLen = 0;
+		break;
+	}
+
+	QL_PRINT_9(ha, "done\n");
+}
+
+/*
+ * ql_dump_cmd
+ *	Performs all EXT_CC_DUMP_OS functions.
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	cmd:	Local EXT_IOCTL cmd struct pointer.
+ *
+ * Returns:
+ *	None, request status indicated in cmd->Status.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static void
+ql_dump_cmd(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
+{
+	caddr_t		dump;
+	uint32_t	sdm_valid_dump = 0;
+	int		rval = 0;
+
+	QL_PRINT_9(ha, "started\n");
+
+	if (ha->ql_dump_state & QL_DUMP_VALID &&
+	    !(ha->ql_dump_state & QL_DUMP_UPLOADED) &&
+	    ha->ql_dump_state != NULL) {
+		sdm_valid_dump = 1;
+	} else {
+		EL(ha, "dump does not exist for instance %d (%x, %p)\n",
+		    ha->instance, ha->ql_dump_state, ha->ql_dump_ptr);
+	}
+
+	cmd->Status = EXT_STATUS_OK;
+	cmd->DetailStatus = 0;
+
+	switch (cmd->SubCode) {
+	case EXT_SC_DUMP_SIZE:
+		cmd->ResponseLen = 0;
+		if (sdm_valid_dump) {
+			cmd->DetailStatus = ha->risc_dump_size;
+		}
+		break;
+	case EXT_SC_DUMP_READ:
+		if (!sdm_valid_dump) {
+			cmd->Status = EXT_STATUS_INVALID_REQUEST;
+			cmd->ResponseLen = 0;
+			break;
+		}
+
+		if (cmd->ResponseLen < ha->risc_dump_size) {
+			cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
+			cmd->DetailStatus = ha->risc_dump_size;
+			EL(ha, "failed, ResponseLen < %x, "
+			    "Len=%xh\n", ha->risc_dump_size,
+			    cmd->ResponseLen);
+			break;
+		}
+
+		ADAPTER_STATE_LOCK(ha);
+		ha->flags |= DISABLE_NIC_FW_DMP;
+		ADAPTER_STATE_UNLOCK(ha);
+
+		QL_DUMP_LOCK(ha);
+
+		dump = kmem_zalloc(ha->risc_dump_size, KM_SLEEP);
+		cmd->ResponseLen = (uint32_t)ql_ascii_fw_dump(ha, dump);
+
+		if ((rval = ddi_copyout((void *)dump,
+		    (void *)(uintptr_t)(cmd->ResponseAdr), cmd->ResponseLen,
+		    mode)) != 0) {
+			ha->ql_dump_state &= ~QL_DUMP_UPLOADED;
+			EL(ha, "failed, ddi_copyout\n");
+			cmd->Status = EXT_STATUS_COPY_ERR;
+			cmd->ResponseLen = 0;
+		} else {
+			ha->ql_dump_state |= QL_DUMP_UPLOADED;
+		}
+
+		kmem_free(dump, ha->risc_dump_size);
+
+		QL_DUMP_UNLOCK(ha);
+
+		ADAPTER_STATE_LOCK(ha);
+		ha->flags &= ~DISABLE_NIC_FW_DMP;
+		ADAPTER_STATE_UNLOCK(ha);
+		break;
+	case EXT_SC_DUMP_TRIGGER:
+		cmd->ResponseLen = 0;
+
+		ADAPTER_STATE_LOCK(ha);
+		ha->flags |= DISABLE_NIC_FW_DMP;
+		ADAPTER_STATE_UNLOCK(ha);
+
+		if (sdm_valid_dump) {
+			cmd->Status = EXT_STATUS_INVALID_REQUEST;
+			EL(ha, "Existing dump file needs to be retrieved.\n");
+		} else {
+			rval = ql_dump_firmware(ha);
+
+			if (rval != QL_SUCCESS && rval != QL_DATA_EXISTS) {
+				cmd->Status = EXT_STATUS_ERR;
+			}
+		}
+
+		ADAPTER_STATE_LOCK(ha);
+		ha->flags &= ~DISABLE_NIC_FW_DMP;
+		ADAPTER_STATE_UNLOCK(ha);
+		break;
+	default:
+		EL(ha, "unknown subcode=%xh\n", cmd->SubCode);
+		cmd->Status = EXT_STATUS_UNSUPPORTED_SUBCODE;
+		cmd->ResponseLen = 0;
+		break;
+	}
+
+	QL_PRINT_9(ha, "done\n");
+}
+
+/*
+ * ql_serdes_reg
+ *	Performs all EXT_CC_SERDES_REG_OP functions.
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	cmd:	EXT_IOCTL cmd struct pointer.
+ *	mode:	flags
+ *
+ * Returns:
+ *	None, request status indicated in cmd->Status.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static void
+ql_serdes_reg(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
+{
+	ql_mbx_data_t	mr = {0};
+	int		rval = 0;
+	EXT_SERDES_REG	serdes_reg = {0};
+
+	QL_PRINT_9(ha, "started\n");
+
+	/* Check if request valid for HBA */
+	if (!(CFG_IST(ha, CFG_SERDES_SUPPORT))) {
+		EL(ha, "invalid request for HBA\n");
+		cmd->Status = EXT_STATUS_INVALID_REQUEST;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	/* Copy in the request structure. */
+	if (ddi_copyin((void *)(uintptr_t)cmd->RequestAdr,
+	    (void *)&serdes_reg, sizeof (EXT_SERDES_REG), mode) != 0) {
+		EL(ha, "failed, ddi_copyin\n");
+		cmd->Status = EXT_STATUS_COPY_ERR;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	switch (cmd->SubCode) {
+	case EXT_SC_WRITE_SERDES_REG:
+		mr.mb[1] = serdes_reg.addr;
+		mr.mb[2] = LSB(serdes_reg.val);
+		mr.mb[3] = 0;
+		mr.mb[4] = MSB(serdes_reg.val);
+		if ((rval = ql_write_serdes(ha, &mr)) != QL_SUCCESS) {
+			/* error */
+			EL(ha, "failed, write_serdes_mbx=%xh\n", rval);
+			cmd->Status = EXT_STATUS_ERR;
+			cmd->ResponseLen = 0;
+			break;
+		} else {
+			cmd->Status = EXT_STATUS_OK;
+		}
+		break;
+	case EXT_SC_READ_SERDES_REG:
+		/* Verify the size of response structure. */
+		if (cmd->ResponseLen < sizeof (EXT_SERDES_REG)) {
+			cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
+			cmd->DetailStatus = sizeof (EXT_SERDES_REG);
+			EL(ha, "failed, ResponseLen < EXT_SERDES_REG, "
+			    "Len=%xh \n", cmd->ResponseLen);
+			cmd->ResponseLen = 0;
+			break;
+		}
+		mr.mb[1] = serdes_reg.addr;
+		if ((rval = ql_read_serdes(ha, &mr)) != QL_SUCCESS) {
+			/* error */
+			EL(ha, "failed, read_serdes_mbx=%xh\n", rval);
+			cmd->Status = EXT_STATUS_ERR;
+			cmd->ResponseLen = 0;
+			break;
+		}
+		serdes_reg.val = CHAR_TO_SHORT(LSB(mr.mb[1]), LSB(mr.mb[2]));
+		/* Copy back the response data */
+		if (ddi_copyout((void *)&serdes_reg,
+		    (void *)(uintptr_t)(cmd->ResponseAdr),
+		    sizeof (EXT_SERDES_REG), mode) != 0) {
+			cmd->Status = EXT_STATUS_COPY_ERR;
+			cmd->ResponseLen = 0;
+			EL(ha, "failed, ddi_copyout\n");
+		} else {
+			cmd->Status = EXT_STATUS_OK;
+			cmd->ResponseLen = sizeof (EXT_SERDES_REG);
+		}
+		break;
+	default:
+		/* Subcode not supported. */
+		EL(ha, "unknown subcode=%xh\n", cmd->SubCode);
+		cmd->Status = EXT_STATUS_UNSUPPORTED_SUBCODE;
+		cmd->ResponseLen = 0;
+		break;
+	}
+
+	QL_PRINT_9(ha, "done\n");
+}
+
+/*
+ * ql_serdes_reg_ex
+ *	Performs all EXT_CC_SERDES_REG_OP_EX functions.
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	cmd:	EXT_IOCTL cmd struct pointer.
+ *	mode:	flags
+ *
+ * Returns:
+ *	None, request status indicated in cmd->Status.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static void
+ql_serdes_reg_ex(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
+{
+	ql_mbx_data_t		mr = {0};
+	int			rval = 0;
+	EXT_SERDES_REG_EX	serdes_reg_ex = {0};
+
+	QL_PRINT_9(ha, "started\n");
+
+	/* Check if request valid for HBA */
+	if (!(CFG_IST(ha, CFG_SERDES_SUPPORT))) {
+		EL(ha, "invalid request for HBA\n");
+		cmd->Status = EXT_STATUS_INVALID_REQUEST;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	/* Copy in the request structure. */
+	if (ddi_copyin((void *)(uintptr_t)cmd->RequestAdr,
+	    (void *)&serdes_reg_ex, sizeof (EXT_SERDES_REG_EX), mode) != 0) {
+		EL(ha, "failed, ddi_copyin\n");
+		cmd->Status = EXT_STATUS_COPY_ERR;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	switch (cmd->SubCode) {
+	case EXT_SC_WRITE_SERDES_REG:
+		mr.mb[3] = LSW(serdes_reg_ex.addr);
+		mr.mb[4] = MSW(serdes_reg_ex.addr);
+		mr.mb[5] = LSW(serdes_reg_ex.val);
+		mr.mb[6] = MSW(serdes_reg_ex.val);
+		if ((rval = ql_write_serdes(ha, &mr)) != QL_SUCCESS) {
+			/* error */
+			EL(ha, "failed, write_serdes_mbx=%xh\n", rval);
+			cmd->Status = EXT_STATUS_ERR;
+			cmd->ResponseLen = 0;
+			break;
+		} else {
+			cmd->Status = EXT_STATUS_OK;
+		}
+		break;
+	case EXT_SC_READ_SERDES_REG:
+		/* Verify the size of response structure. */
+		if (cmd->ResponseLen < sizeof (EXT_SERDES_REG_EX)) {
+			cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
+			cmd->DetailStatus = sizeof (EXT_SERDES_REG_EX);
+			EL(ha, "failed, ResponseLen < EXT_SERDES_REG_EX, "
+			    "Len=%xh\n", cmd->ResponseLen);
+			cmd->ResponseLen = 0;
+			break;
+		}
+		mr.mb[3] = LSW(serdes_reg_ex.addr);
+		mr.mb[4] = MSW(serdes_reg_ex.addr);
+		if ((rval = ql_read_serdes(ha, &mr)) != QL_SUCCESS) {
+			/* error */
+			EL(ha, "failed, read_serdes_mbx=%xh\n", rval);
+			cmd->Status = EXT_STATUS_ERR;
+			cmd->ResponseLen = 0;
+			break;
+		}
+		serdes_reg_ex.val = SHORT_TO_LONG(mr.mb[1], mr.mb[2]);
+		/* Copy back the response data */
+		if (ddi_copyout((void *)&serdes_reg_ex,
+		    (void *)(uintptr_t)(cmd->ResponseAdr),
+		    sizeof (EXT_SERDES_REG_EX), mode) != 0) {
+			cmd->Status = EXT_STATUS_COPY_ERR;
+			cmd->ResponseLen = 0;
+			EL(ha, "failed, ddi_copyout\n");
+		} else {
+			cmd->Status = EXT_STATUS_OK;
+			cmd->ResponseLen = sizeof (EXT_SERDES_REG_EX);
+		}
+		break;
+	default:
+		/* Subcode not supported. */
+		EL(ha, "unknown subcode=%xh\n", cmd->SubCode);
+		cmd->Status = EXT_STATUS_UNSUPPORTED_SUBCODE;
+		cmd->ResponseLen = 0;
+		break;
+	}
+
+	QL_PRINT_9(ha, "done\n");
+}
+
+/*
+ * ql_els_passthru
+ *	IOCTL for extended link service passthru command.
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	cmd:	User space CT arguments pointer.
+ *	mode:	flags.
+ *
+ * Returns:
+ *	None, request status indicated in cmd->Status.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static void
+ql_els_passthru(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
+{
+	ql_mbx_iocb_t		*pkt;
+	dma_mem_t		*dma_mem;
+	caddr_t			bp, pld;
+	uint32_t		pkt_size, pld_byte_cnt, cmd_size, *long_ptr;
+	EXT_ELS_PT_REQ		*pt_req;
+	boolean_t		local_hba = B_FALSE;
+	ql_tgt_t		*tq = NULL;
+	port_id_t		tmp_fcid;
+	int			rval;
+	uint16_t		comp_status;
+
+	QL_PRINT_9(ha, "started\n");
+
+	if (DRIVER_SUSPENDED(ha)) {
+		EL(ha, "failed, LOOP_NOT_READY\n");
+		cmd->Status = EXT_STATUS_BUSY;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	if (cmd->RequestLen < sizeof (EXT_ELS_PT_REQ)) {
+		/* parameter error */
+		EL(ha, "failed, RequestLen < EXT_ELS_PT_REQ, Len=%xh\n",
+		    cmd->RequestLen);
+		cmd->Status = EXT_STATUS_INVALID_PARAM;
+		cmd->DetailStatus = EXT_DSTATUS_REQUEST_LEN;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	/* Allocate memory for command. */
+	bp = kmem_zalloc(cmd->RequestLen, KM_SLEEP);
+
+	if (ddi_copyin((void*)(uintptr_t)cmd->RequestAdr,
+	    bp, cmd->RequestLen, mode) != 0) {
+		EL(ha, "failed, ddi_copyin\n");
+		kmem_free(bp, cmd->RequestLen);
+		cmd->Status = EXT_STATUS_COPY_ERR;
+		cmd->ResponseLen = 0;
+		return;
+	}
+	pt_req = (EXT_ELS_PT_REQ *)bp;
+
+	QL_PRINT_9(ha, "EXT_ELS_PT_REQ\n");
+	QL_DUMP_9((uint8_t *)pt_req, 8, sizeof (EXT_ELS_PT_REQ));
+
+	/* Find loop ID of the device */
+	if (pt_req->ValidMask & EXT_DEF_WWPN_VALID) {
+		if (bcmp(ha->loginparams.nport_ww_name.raw_wwn, pt_req->WWPN,
+		    EXT_DEF_WWN_NAME_SIZE) == 0) {
+			local_hba = B_TRUE;
+		} else {
+			tq = ql_find_port(ha, pt_req->WWPN, QLNT_PORT);
+		}
+	} else if (pt_req->ValidMask & EXT_DEF_PID_VALID) {
+		/*
+		 * Copy caller's d_id to tmp space.
+		 */
+		bcopy(&pt_req->Id[1], tmp_fcid.r.d_id,
+		    EXT_DEF_PORTID_SIZE_ACTUAL);
+		BIG_ENDIAN_24(&tmp_fcid.r.d_id[0]);
+
+		if (bcmp((void *)&ha->d_id, (void *)tmp_fcid.r.d_id,
+		    EXT_DEF_PORTID_SIZE_ACTUAL) == 0) {
+			local_hba = B_TRUE;
+		} else {
+			tq = ql_find_port(ha, (uint8_t *)tmp_fcid.r.d_id,
+			    QLNT_PID);
+		}
+	} else if (pt_req->ValidMask & EXT_DEF_WWNN_VALID) {
+		if (bcmp(ha->loginparams.node_ww_name.raw_wwn, pt_req->WWNN,
+		    EXT_DEF_WWN_NAME_SIZE) == 0) {
+			local_hba = B_TRUE;
+		} else {
+			tq = ql_find_port(ha, pt_req->WWNN, QLNT_NODE);
+		}
+	}
+
+	if (local_hba == B_TRUE) {
+		EL(ha, "failed, els to adapter\n");
+		kmem_free(bp, cmd->RequestLen);
+		cmd->Status = EXT_STATUS_ERR;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	if (tq == NULL) {
+		/* no matching device */
+		EL(ha, "failed, device not found\n");
+		kmem_free(bp, cmd->RequestLen);
+		cmd->Status = EXT_STATUS_DEV_NOT_FOUND;
+		cmd->DetailStatus = EXT_DSTATUS_TARGET;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	/* Allocate a DMA Memory Descriptor */
+	dma_mem = (dma_mem_t *)kmem_zalloc(sizeof (dma_mem_t), KM_SLEEP);
+	if (dma_mem == NULL) {
+		EL(ha, "failed, kmem_zalloc\n");
+		kmem_free(bp, cmd->RequestLen);
+		cmd->Status = EXT_STATUS_NO_MEMORY;
+		cmd->ResponseLen = 0;
+		return;
+	}
+	/* Determine maximum buffer size. */
+	cmd_size = cmd->RequestLen - sizeof (EXT_ELS_PT_REQ);
+	pld_byte_cnt = cmd_size < cmd->ResponseLen ? cmd->ResponseLen :
+	    cmd_size;
+	pld = (caddr_t)(bp + sizeof (EXT_ELS_PT_REQ));
+
+	/* Allocate command block. */
+	pkt_size = (uint32_t)(sizeof (ql_mbx_iocb_t));
+	pkt = kmem_zalloc(pkt_size, KM_SLEEP);
+	if (pkt == NULL) {
+		EL(ha, "failed, kmem_zalloc\n");
+		kmem_free(dma_mem, sizeof (dma_mem_t));
+		kmem_free(bp, cmd->RequestLen);
+		cmd->Status = EXT_STATUS_NO_MEMORY;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	/* Get DMA memory for the payload */
+	if (ql_get_dma_mem(ha, dma_mem, pld_byte_cnt, LITTLE_ENDIAN_DMA,
+	    QL_DMA_RING_ALIGN) != QL_SUCCESS) {
+		cmn_err(CE_WARN, "%sDMA memory alloc failed", QL_NAME);
+		kmem_free(pkt, pkt_size);
+		kmem_free(dma_mem, sizeof (dma_mem_t));
+		kmem_free(bp, cmd->RequestLen);
+		cmd->Status = EXT_STATUS_MS_NO_RESPONSE;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	/* Copy out going payload data to IOCB DMA buffer. */
+	ddi_rep_put8(dma_mem->acc_handle, (uint8_t *)pld,
+	    (uint8_t *)dma_mem->bp, cmd_size, DDI_DEV_AUTOINCR);
+
+	/* Sync IOCB DMA buffer. */
+	(void) ddi_dma_sync(dma_mem->dma_handle, 0, cmd_size,
+	    DDI_DMA_SYNC_FORDEV);
+
+	/*
+	 * Setup IOCB
+	 */
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
+		pkt->els.entry_type = ELS_PASSTHRU_TYPE;
+		pkt->els.entry_count = 1;
+
+		/* Set loop ID */
+		pkt->els.n_port_hdl = tq->loop_id;
+
+		/* Set cmd/response data segment counts. */
+		pkt->els.xmt_dseg_count = LE_16(1);
+		pkt->els.vp_index = ha->vp_index;
+		pkt->els.rcv_dseg_count = LE_16(1);
+
+		pkt->els.els_cmd_opcode = pld[0];
+
+		pkt->els.d_id_7_0 = tq->d_id.b.al_pa;
+		pkt->els.d_id_15_8 = tq->d_id.b.area;
+		pkt->els.d_id_23_16 = tq->d_id.b.domain;
+
+		pkt->els.s_id_7_0 = ha->d_id.b.al_pa;
+		pkt->els.s_id_15_8 = ha->d_id.b.area;
+		pkt->els.s_id_23_16 = ha->d_id.b.domain;
+
+		/* Load rsp byte count. */
+		pkt->els.rcv_payld_data_bcnt = LE_32(cmd->ResponseLen);
+
+		/* Load cmd byte count. */
+		pkt->els.xmt_payld_data_bcnt = LE_32(cmd_size);
+
+		long_ptr = (uint32_t *)&pkt->els.dseg;
+
+		/* Load MS command entry data segments. */
+		*long_ptr++ = (uint32_t)
+		    LE_32(LSD(dma_mem->cookie.dmac_laddress));
+		*long_ptr++ = (uint32_t)
+		    LE_32(MSD(dma_mem->cookie.dmac_laddress));
+		*long_ptr++ = LE_32(cmd_size);
+
+		/* Load MS response entry data segments. */
+		*long_ptr++ = (uint32_t)
+		    LE_32(LSD(dma_mem->cookie.dmac_laddress));
+		*long_ptr++ = (uint32_t)
+		    LE_32(MSD(dma_mem->cookie.dmac_laddress));
+		*long_ptr = LE_32(cmd->ResponseLen);
+
+		rval = ql_issue_mbx_iocb(ha, (caddr_t)pkt,
+		    sizeof (ql_mbx_iocb_t));
+
+		comp_status = (uint16_t)LE_16(pkt->sts24.comp_status);
+		if (rval == QL_SUCCESS && comp_status == CS_DATA_UNDERRUN) {
+			comp_status = CS_COMPLETE;
+		}
+		if (rval != QL_SUCCESS ||
+		    (pkt->sts24.entry_status & 0x3c) != 0 ||
+		    comp_status != CS_COMPLETE) {
+			EL(ha, "failed, I/O timeout, cs=%xh, es=%xh, "
+			    "rval=%xh\n",
+			    comp_status, pkt->sts24.entry_status, rval);
+			ql_free_dma_resource(ha, dma_mem);
+			kmem_free(pkt, pkt_size);
+			kmem_free(dma_mem, sizeof (dma_mem_t));
+			kmem_free(bp, cmd->RequestLen);
+			cmd->Status = EXT_STATUS_ERR;
+			cmd->ResponseLen = 0;
+			return;
+		}
+	} else {
+		pkt->ms.entry_type = MS_TYPE;
+		pkt->ms.entry_count = 1;
+
+		/* Set loop ID */
+		if (CFG_IST(ha, CFG_EXT_FW_INTERFACE)) {
+			pkt->ms.loop_id_l = LSB(tq->loop_id);
+			pkt->ms.loop_id_h = MSB(tq->loop_id);
+		} else {
+			pkt->ms.loop_id_h = LSB(tq->loop_id);
+		}
+
+		pkt->ms.control_flags_h = CF_ELS_PASSTHROUGH;
+
+		/* Set ISP command timeout. */
+		pkt->ms.timeout = LE_16(120);
+
+		/* Set data segment counts. */
+		pkt->ms.cmd_dseg_count_l = 1;
+		pkt->ms.total_dseg_count = LE_16(2);
+
+		/* Response total byte count. */
+		pkt->ms.resp_byte_count = LE_32(cmd->ResponseLen);
+		pkt->ms.dseg[1].length = LE_32(cmd->ResponseLen);
+
+		/* Command total byte count. */
+		pkt->ms.cmd_byte_count = LE_32(cmd_size);
+		pkt->ms.dseg[0].length = LE_32(cmd_size);
+
+		/* Load command/response data segments. */
+		pkt->ms.dseg[0].address[0] = (uint32_t)
+		    LE_32(LSD(dma_mem->cookie.dmac_laddress));
+		pkt->ms.dseg[0].address[1] = (uint32_t)
+		    LE_32(MSD(dma_mem->cookie.dmac_laddress));
+		pkt->ms.dseg[1].address[0] = (uint32_t)
+		    LE_32(LSD(dma_mem->cookie.dmac_laddress));
+		pkt->ms.dseg[1].address[1] = (uint32_t)
+		    LE_32(MSD(dma_mem->cookie.dmac_laddress));
+
+		rval = ql_issue_mbx_iocb(ha, (caddr_t)pkt,
+		    sizeof (ql_mbx_iocb_t));
+
+		comp_status = (uint16_t)LE_16(pkt->sts.comp_status);
+		if (rval == QL_SUCCESS && comp_status == CS_DATA_UNDERRUN) {
+			comp_status = CS_COMPLETE;
+		}
+		if (rval != QL_SUCCESS ||
+		    (pkt->sts.entry_status & 0x7e) != 0 ||
+		    comp_status != CS_COMPLETE) {
+			EL(ha, "failed, I/O timeout, cs=%xh, es=%xh, "
+			    "rval=%xh\n",
+			    comp_status, pkt->sts.entry_status, rval);
+			ql_free_dma_resource(ha, dma_mem);
+			kmem_free(pkt, pkt_size);
+			kmem_free(dma_mem, sizeof (dma_mem_t));
+			kmem_free(bp, cmd->RequestLen);
+			cmd->Status = EXT_STATUS_ERR;
+			cmd->ResponseLen = 0;
+			return;
+		}
+	}
+
+	/* Sync payload DMA buffer. */
+	(void) ddi_dma_sync(dma_mem->dma_handle, 0, cmd->ResponseLen,
+	    DDI_DMA_SYNC_FORKERNEL);
+
+	if (ql_send_buffer_data(dma_mem->bp,
+	    (caddr_t)(uintptr_t)cmd->ResponseAdr,
+	    cmd->ResponseLen, mode) != cmd->ResponseLen) {
+		cmd->Status = EXT_STATUS_COPY_ERR;
+		EL(ha, "failed, ddi_copyout\n");
+	} else {
+		QL_PRINT_9(ha, "els_rsp\n");
+		QL_DUMP_9(pld, 8, cmd->ResponseLen);
+		cmd->Status = EXT_STATUS_OK;
+		QL_PRINT_9(ha, "done\n");
+	}
+
+	ql_free_dma_resource(ha, dma_mem);
+	kmem_free(pkt, pkt_size);
+	kmem_free(dma_mem, sizeof (dma_mem_t));
+	kmem_free(bp, cmd->RequestLen);
+}
+
+/*
+ * ql_flash_update_caps
+ *	IOCTL for flash update capabilities command.
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	cmd:	User space CT arguments pointer.
+ *	mode:	flags.
+ *
+ * Returns:
+ *	None, request status indicated in cmd->Status.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static void
+ql_flash_update_caps(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
+{
+	int			rval;
+	uint64_t		cb;
+	EXT_FLASH_UPDATE_CAPS	caps = {0};
+
+	QL_PRINT_9(ha, "started\n");
+
+	cb = LONG_TO_LLONG(ha->fw_attributes, ha->fw_ext_attributes);
+
+	switch (cmd->SubCode) {
+	case EXT_SC_GET_FLASH_UPDATE_CAPS:
+		if (cmd->ResponseLen < sizeof (EXT_FLASH_UPDATE_CAPS)) {
+			cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
+			cmd->DetailStatus = sizeof (EXT_FLASH_UPDATE_CAPS);
+			EL(ha, "failed, ResponseLen < 0x%x, Len=0x%x\n",
+			    sizeof (EXT_FLASH_UPDATE_CAPS), cmd->ResponseLen);
+			cmd->ResponseLen = 0;
+			return;
+		}
+		caps.Capabilities = cb;
+		caps.OutageDuration = 300;	/* seconds */
+
+		rval = ddi_copyout((void *)&caps,
+		    (void *)(uintptr_t)(cmd->ResponseAdr),
+		    sizeof (EXT_FLASH_UPDATE_CAPS), mode);
+		if (rval != 0) {
+			cmd->Status = EXT_STATUS_COPY_ERR;
+			cmd->ResponseLen = 0;
+			EL(ha, "failed, ddi_copyout\n");
+		} else {
+			cmd->ResponseLen = sizeof (EXT_FLASH_UPDATE_CAPS);
+		}
+		break;
+	case EXT_SC_SET_FLASH_UPDATE_CAPS:
+		if (cmd->RequestLen < sizeof (EXT_FLASH_UPDATE_CAPS)) {
+			/* parameter error */
+			EL(ha, "failed, RequestLen < EXT_FLASH_UPDATE_CAPS, "
+			    "Len=%xh\n", cmd->RequestLen);
+			cmd->Status = EXT_STATUS_INVALID_PARAM;
+			cmd->DetailStatus = EXT_DSTATUS_REQUEST_LEN;
+			cmd->ResponseLen = 0;
+			return;
+		}
+
+		/* Copy in the request structure. */
+		if (ddi_copyin((void *)(uintptr_t)cmd->RequestAdr,
+		    (void *)&caps, sizeof (EXT_FLASH_UPDATE_CAPS), mode) != 0) {
+			EL(ha, "failed, ddi_copyin\n");
+			cmd->Status = EXT_STATUS_COPY_ERR;
+			cmd->ResponseLen = 0;
+			return;
+		}
+
+		if (cb != caps.Capabilities || caps.OutageDuration < 300) {
+			cmd->Status = EXT_STATUS_ERR;
+			cmd->ResponseLen = 0;
+		}
+		break;
+	default:
+		/* Subcode not supported. */
+		EL(ha, "unknown subcode=%xh\n", cmd->SubCode);
+		cmd->Status = EXT_STATUS_UNSUPPORTED_SUBCODE;
+		cmd->ResponseLen = 0;
+		break;
+	}
+
+	QL_PRINT_9(ha, "done\n");
+}
+
+/*
+ * ql_get_bbcr_data
+ *	IOCTL for get buffer to buffer credits command.
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	cmd:	User space CT arguments pointer.
+ *	mode:	flags.
+ *
+ * Returns:
+ *	None, request status indicated in cmd->Status.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static void
+ql_get_bbcr_data(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
+{
+	int		rval;
+	ql_mbx_data_t	mr;
+	EXT_BBCR_DATA	bb = {0};
+
+	QL_PRINT_9(ha, "started\n");
+
+	if (cmd->ResponseLen < sizeof (EXT_BBCR_DATA)) {
+		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
+		cmd->DetailStatus = sizeof (EXT_BBCR_DATA);
+		EL(ha, "failed, ResponseLen < 0x%x, Len=0x%x\n",
+		    sizeof (EXT_BBCR_DATA), cmd->ResponseLen);
+		cmd->ResponseLen = 0;
+		return;
+	}
+
+	if (!(CFG_IST(ha, CFG_BBCR_SUPPORT))) {
+		EL(ha, "invalid request for HBA\n");
+		cmd->Status = EXT_STATUS_INVALID_REQUEST;
+		cmd->ResponseLen = 0;
+		return;
+	}
+	if (ha->task_daemon_flags & LOOP_DOWN) {
+		rval = ql_get_adapter_id(ha, &mr);
+		ha->bbcr_initial = LSB(mr.mb[15]);
+		ha->bbcr_runtime = MSB(mr.mb[15]);
+		bb.ConfiguredBBSCN = ha->bbcr_initial & BBCR_INITIAL_MASK;
+		bb.NegotiatedBBSCN = ha->bbcr_runtime & BBCR_RUNTIME_MASK;
+		bb.Status = EXT_DEF_BBCR_STATUS_UNKNOWN;
+		bb.State = EXT_DEF_BBCR_STATE_OFFLINE;
+		if (rval == 0x4005) {
+			bb.mbx1 = mr.mb[1];
+		}
+	} else {
+		bb.ConfiguredBBSCN = ha->bbcr_initial & BBCR_INITIAL_MASK;
+		bb.NegotiatedBBSCN = ha->bbcr_runtime & BBCR_RUNTIME_MASK;
+
+		if (bb.ConfiguredBBSCN) {
+			bb.Status = EXT_DEF_BBCR_STATUS_ENABLED;
+			if (bb.NegotiatedBBSCN &&
+			    !(ha->bbcr_runtime & BBCR_RUNTIME_REJECT)) {
+				bb.State = EXT_DEF_BBCR_STATE_ONLINE;
+			} else {
+				bb.State = EXT_DEF_BBCR_STATE_OFFLINE;
+				if (ha->bbcr_runtime & BBCR_RUNTIME_REJECT) {
+					bb.OfflineReasonCode =
+					    EXT_DEF_BBCR_REASON_LOGIN_REJECT;
+				} else {
+					bb.OfflineReasonCode =
+					    EXT_DEF_BBCR_REASON_SWITCH;
+				}
+			}
+		} else {
+			bb.Status = EXT_DEF_BBCR_STATUS_DISABLED;
+		}
+	}
+
+	rval = ddi_copyout((void *)&bb, (void *)(uintptr_t)(cmd->ResponseAdr),
+	    sizeof (EXT_BBCR_DATA), mode);
+	if (rval != 0) {
+		cmd->Status = EXT_STATUS_COPY_ERR;
+		cmd->ResponseLen = 0;
+		EL(ha, "failed, ddi_copyout\n");
+	} else {
+		cmd->ResponseLen = sizeof (EXT_BBCR_DATA);
+	}
+
+	QL_PRINT_9(ha, "done\n");
+}
+
+/*
+ * ql_get_priv_stats
+ *	Performs EXT_SC_GET_PRIV_STATS subcommand. of EXT_CC_GET_DATA.
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	cmd:	Local EXT_IOCTL cmd struct pointer.
+ *	mode:	flags.
+ *
+ * Returns:
+ *	None, request status indicated in cmd->Status.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static void
+ql_get_priv_stats(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
+{
+	uint8_t	*ls;
+	int	rval;
+	int	retry = 10;
+
+	QL_PRINT_9(ha, "started\n");
+
+	while (ha->task_daemon_flags & (DRIVER_STALL | ABORT_ISP_ACTIVE |
+	    LOOP_RESYNC_ACTIVE)) {
+		ql_delay(ha, 10000000);	/* 10 second delay */
+
+		retry--;
+
+		if (retry == 0) { /* effectively 100 seconds */
+			EL(ha, "failed, LOOP_NOT_READY\n");
+			cmd->Status = EXT_STATUS_BUSY;
+			cmd->ResponseLen = 0;
+			return;
+		}
+	}
+
+	/* Allocate memory for command. */
+	ls = kmem_zalloc(cmd->ResponseLen, KM_SLEEP);
+
+	/*
+	 * I think these are supposed to be port statistics
+	 * the loop ID or port ID should be in cmd->Instance.
+	 */
+	rval = ql_get_status_counts(ha,
+	    ha->task_daemon_flags & LOOP_DOWN ? 0xFF : ha->loop_id,
+	    cmd->ResponseLen, (caddr_t)ls, 0);
+	if (rval != QL_SUCCESS) {
+		EL(ha, "failed, get_link_status=%xh, id=%xh\n", rval,
+		    ha->loop_id);
+		cmd->Status = EXT_STATUS_MAILBOX;
+		cmd->DetailStatus = rval;
+		cmd->ResponseLen = 0;
+	} else {
+		rval = ddi_copyout((void *)&ls,
+		    (void *)(uintptr_t)cmd->ResponseAdr, cmd->ResponseLen,
+		    mode);
+		if (rval != 0) {
+			EL(ha, "failed, ddi_copyout\n");
+			cmd->Status = EXT_STATUS_COPY_ERR;
+			cmd->ResponseLen = 0;
+		}
+	}
+
+	kmem_free(ls, cmd->ResponseLen);
+
+	QL_PRINT_9(ha, "done\n");
 }
